// declaration for class manipulating data for output into a text file
//
// Edward Daw, 8th September 2000
#ifndef Rms_output_HH
#define Rms_output_HH

#include <stdio.h>

class Rms_output {

public:

  Rms_output( char* file_name, int no_of_columns );

  int update_samp_rate( int column,
			int value );

  int add_header( char* first_header_line,
		  char* second_header_line,
		  int column_number );
  
  int add_data( float value , int column_number );

  int log_error( char* error_string, Time gpstime );

  // call this function to disable the printing of text to the file
  void disableTextOutput(void);

  // call this function to enable the printing of text to the file
  void enableTextOutput(void);

  ~Rms_output( );
  int entry_length;
  int total_no_of_columns;
  char output_file_name[ 100 ];
  int current_column_number;
  int lines_of_data_written;
  long int gps_time_for_entry;
  int* samp_rate_array;
private:

  // flag for whether to actually make text file
  bool _make_text_file;

  // C style file pointer
  FILE* out;

  // arrays of characters to hold header information
  char* header_line_1_set;
  char* header_line_2_set;

  // arrays to hold the data
  float* data_array;

  // flags set to YES when header is finished.
  int header_finished;

};

#endif // Rms_output_HH
